ExaltedWithFloor = LibStub("AceAddon-3.0"):NewAddon("Exalted with the Floor", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0", "AceTimer-3.0")

AceGUI = LibStub("AceGUI-3.0")

local FACTION_BAR_COLOURS = {
    [1] = {r = 0.9, g = 0.7, b = 0},
    [2] = {r = 0, g = 0.6, b = 0.1},
    [3] = {r = 0, g = 0.6, b = 0.1},
    [4] = {r = 0, g = 0.6, b = 0.1},
    [5] = {r = 0, g = 0.6, b = 0.1},
};

local NUM_OF_WORLD_SUB_SECTIONS = 7
local MSG_PREFIX_SEND = "RWFSTP"
local MSG_PREFIX_TOOLTIP = "RWFTP"
local DEATH_COUNT = 0
local lineAdded = false

local defaults = {
    profile = {
        guildEnable = true,
    },
  char = {
	version = 1.0,
	floorReps = {
		{id=1, name = "Floor", desc = "", barMin = 0, barMax = 0, barValue = 0, isHeader = true, hasRep = false, isChild = false, isCollapsed = false}, 
		{id=2, name = "Dungeon", desc = "Floor reputation gained while in Dungeons", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=3, name = "Scenario", desc = "Floor reputation gained while in a Scenario", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=4, name = "Arena", desc = "Floor reputation gained while in a Arena", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=5, name = "Brawler's Guild", desc = "Floor reputation gained while in the Brawler's Guild", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		
		{id=10, name = "World Floors", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = true, hasRep = true, isChild = false, isCollapsed = false},
		{id=11, name = "Eastern Kingdoms", desc = "Floor reputation gained while in Eastern Kingdoms", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=12, name = "Kalimdor", desc = "Floor reputation gained while in Kalimdor", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=13, name = "Outlands", desc = "Floor reputation gained while in Outlands", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=14, name = "Northrend", desc = "Floor reputation gained while in Northrend", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=15, name = "Pandaria", desc = "Floor reputation gained while in Pandaria", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
		{id=16, name = "Draenor", desc = "Floor reputation gained while in Draenor", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
        {id=17, name = "Broken Isles", desc = "Floor reputation gained while in Broken Isles", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 

		{id=100, name = "Raid Floors", desc = "", barMin = 0, barMax = 0, barValue = 0, isHeader = true, hasRep = false, isChild = false, isCollapsed = false}, 
        {id=101, name = "Legion", desc = "", barMin = 0, barMax = 0, barValue = 0, isHeader = true, hasRep = false, isChild = true, isCollapsed = false}, 
        {id=102, name = "The Nighthold", desc = "Floor reputation gained while in the Nighthold", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
        {id=104, name = "The Emerald Nightmare", desc = "Floor reputation gained while in the Emerald Nightmare", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
        
        {id=110, name = "Warlords of Draenor", desc = "", barMin = 0, barMax = 0, barValue = 0, isHeader = true, hasRep = false, isChild = true, isCollapsed = false}, 
        {id=111, name = "Hellfire Citadel", desc = "Floor reputation gained while in the Hellfire Citadel", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
        {id=112, name = "Blackrock Foundry", desc = "Floor reputation gained while in the Blackrock Foundry", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
        {id=113, name = "Highmaul", desc = "Floor reputation gained while in Highmaul", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
        
        {id=120, name = "Mists of Pandaria", desc = "", barMin = 0, barMax = 0, barValue = 0, isHeader = true, hasRep = false, isChild = true, isCollapsed = false}, 
		{id=121, name = "Siege of Orgrimmar", desc = "Floor reputation gained while in the Siege of Orgrimmer", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
		{id=122, name = "Throne of Thunder", desc = "Floor reputation gained while in the Throne of Thunder", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
		{id=123, name = "Terrace of Endless Springs", desc = "Floor reputation gained while in the Terrace of Endless Springs", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
		{id=124, name = "Heart of Fear", desc = "Floor reputation gained while in the Heart of Fear", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
		{id=125, name = "Mogu'shan Palace", desc = "Floor reputation gained while in the Mogu'shan Palace", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
        {id=126, name = "Previous Raid", desc = "Floor reputation gained while in raids pre Mists of Pandaria", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		
		{id=200, name = "Battleground Floors", desc = "", barMin = 0, barMax = 0, barValue = 0, isHeader = true, hasRep = false, isChild = false, isCollapsed = false},
		{id=201, name = "Arathi Basin", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=202, name = "Warsong Gulch", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=203, name = "Eye of the Storm", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=204, name = "Alterac Valley", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=205, name = "Strand of the Ancients", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=206, name = "Isle of Conquest", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=207, name = "Twin Peaks", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=208, name = "The Battle for Gilneas", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=209, name = "Temple of Kotmogu", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=210, name = "Silvershard Mines", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},
		{id=211, name = "Deepwind Gorge", desc = "", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false},

        {id=103, name = "Trial of Valor", desc = "Floor reputation gained while in the Trial of Valor", barMin = 0, barMax = 3000, barValue = 0, isHeader = false, hasRep = true, isChild = true, isCollapsed = false}, 
		},
	}
}

myOptions = {
    name = "Global Options",
    type = "group",
    args = {
        guild = {
            name = "Announce to Guild",
            desc = "Turns on/off the ability to announce your new standings with the reputations to your guild",
            type = "toggle",
            set = function(info,val) ExaltedWithFloor.db.profile.guildEnable = val end,
		    get = function(info) return ExaltedWithFloor.db.profile.guildEnable end
        },
    }
}


local AceConfig = LibStub("AceConfig-3.0")
AceConfig:RegisterOptionsTable("Exalted With The Floor", myOptions)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Exalted With The Floor")
local VERSION = GetAddOnMetadata("ExaltedWithTheFloor", "Version")

function ExaltedWithFloor:OnInitialize()        
	self.db = LibStub("AceDB-3.0"):New("ExaltedWithFloorDB", defaults)
	ExaltedWithFloor:RegisterEvent("PLAYER_DEAD", RWFDeath)
	ExaltedWithFloor:RegisterEvent("UPDATE_MOUSEOVER_UNIT", ExaltedWithFloor_ToolTip) 	
end

function ExaltedWithFloor:OnEnable()
	original_RWF_ReputationFrame_OnShow = ReputationFrame_OnShow
	ExaltedWithFloor:RegisterComm(MSG_PREFIX_SEND)
	ExaltedWithFloor:RegisterComm(MSG_PREFIX_TOOLTIP)
end

function ExaltedWithFloor_ToolTip()
	local name, faction = UnitName("mouseover")
	if (UnitExists("mouseover") == 1 and not UnitAffectingCombat("player") and name ~= "Unknown" ) then
		if (UnitIsPlayer("mouseover") == 1 and UnitIsFriend("player", "mouseover")) then
			local name, type, _, difficulty = GetInstanceInfo()
            local T = ExaltedWithFloor.db.char.floorReps
            local sortted = sortTable(T)
			for id, value in pairs(sortted) do
				if ( T[value].name == FloorType(name, type, difficulty)) then
					local sendMessage = T[value].name.."."..id
					local sendTo = GetUnitName("mouseover", true)
					ExaltedWithFloor:SendCommMessage(MSG_PREFIX_SEND, sendMessage, "WHISPER", sendTo)
					break
				end
			end
		end
	end
end

function ExaltedWithFloor:OnCommReceived(prefix, message, distribution, sender)
	local playerName = UnitName("player")
	if (prefix == MSG_PREFIX_SEND) then
		local name, id = strsplit(".", message)
		local standing, _ = GetFloorStandingText(tonumber(id))
		local current, max
        
		for id, value in pairs(ExaltedWithFloor.db.char.floorReps) do
			if ( value.name == name) then
				current = value.barValue
				max = value.barMax
				break
			end
		end

		if( name ~= nil and standing ~= nil and current ~= nil and max ~= nil) then
			local sendMessage = name..": "..standing.." ("..current.."/"..max..")"
			ExaltedWithFloor:SendCommMessage(MSG_PREFIX_TOOLTIP, sendMessage, "WHISPER", sender)
		end
	end
	if (prefix == MSG_PREFIX_TOOLTIP and sender == GetUnitName("mouseover", true) and lineAdded == false) then
		lineAdded = true
		GameTooltip:AddLine(message, 1,1,1,1)    
		GameTooltip:Show()
	end
end

local function OnTooltipCleared(tooltip, ...)
   lineAdded = false
end

GameTooltip:HookScript("OnTooltipCleared", OnTooltipCleared)

function tableLength(T) 
	local c = 0 
	for _, v in pairs(T) do 
		if (v.isCollapsed == true and v.isChild == true) then
		else
			c = c + 1
		end 
	end 
	return c 
end

function RealTableLength(T) 
	local b = 0 
	for _, v in pairs(T) do b = b + 1 end
	return b
end

ReputationFrame:HookScript("OnShow", function(frame)
	RWF_ReputationDetailButton:Show()
	original_RWF_ReputationFrame_OnShow()
	end)

function RWF_Update()
	local numFactions = tableLength(ExaltedWithFloor.db.char.floorReps)

	if ( not FauxScrollFrame_Update(RWF_ReputationListScrollFrame, numFactions, 15, 26 ) ) then
        RWF_ReputationListScrollFrameScrollBar:SetValue(0);
    end

    local factionOffset = FauxScrollFrame_GetOffset(RWF_ReputationListScrollFrame);

    --TODO fix this (15 is max number of values shown)
	for i=1, 15, 1 do
		local factionIndex = factionOffset + i;
        local factionRow = _G["RWF_ReputationBar"..i];
        local factionBar = _G["RWF_ReputationBar"..i.."ReputationBar"];
        local factionTitle = _G["RWF_ReputationBar"..i.."FactionName"];
        local factionButton = _G["RWF_ReputationBar"..i.."ExpandOrCollapseButton"];
        local factionStanding = _G["RWF_ReputationBar"..i.."ReputationBarFactionStanding"];
        local factionBackground = _G["RWF_ReputationBar"..i.."Background"];

        --if ( factionIndex <= numFactions ) then
			local name, description, barMin, barMax, barValue, isHeader, hasRep, isChild, isCollapsed = GetFloorInfo(factionIndex);
			factionTitle:SetText(name);

			if ( isCollapsed ) then
                factionButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
            else
                factionButton:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up"); 
            end

            factionRow.index = factionIndex;
            factionRow.isCollapsed = isCollapsed;
			local factionStandingText, standingID = GetFloorStandingText(factionIndex)

			factionStanding:SetText(factionStandingText);

			--Normalize Values
            barMax = barMax - barMin;
            barValue = barValue - barMin;
            barMin = 0;

            factionRow.standingText = factionStandingText;
			factionBar:SetMinMaxValues(0, barMax);
            factionBar:SetValue(barValue);
			local barColour = FACTION_BAR_COLOURS[standingID];
			factionBar:SetStatusBarColor(barColour.r, barColour.g, barColour.b);
			factionRow.tooltip = barValue.." / "..barMax;
			RWF_ReputationFrame_SetRowType(factionRow, isChild, isHeader, hasRep);

            factionRow:Show();
		--else
            --factionRow:Hide();
		--end
	end
end

function RWF_ReputationFrame_SetRowType(factionRow, isChild, isHeader, hasRep)  --rowType is a binary table of type isHeader, isChild
    local factionRowName = factionRow:GetName()
    local factionBar = _G[factionRowName.."ReputationBar"];
    local factionTitle = _G[factionRowName.."FactionName"];
    local factionStanding = _G[factionRowName.."ReputationBarFactionStanding"];
    local factionBackground = _G[factionRowName.."Background"];
    local factionButton = _G[factionRowName.."ExpandOrCollapseButton"];
    local factionLeftTexture = _G[factionRowName.."ReputationBarLeftTexture"];
    local factionRightTexture = _G[factionRowName.."ReputationBarRightTexture"];

    factionLeftTexture:SetWidth(62);
    factionRightTexture:SetWidth(42);
    factionBar:SetPoint("RIGHT", factionRow, "RIGHT", 0, 0);

    if ( isHeader ) then
        if ( isChild ) then
            factionRow:SetPoint("LEFT", RWF_SubFrame, "LEFT", 29, 0);
            factionTitle:SetWidth(135);
        else
            factionRow:SetPoint("LEFT", RWF_SubFrame, "LEFT", 0, 0);
            factionTitle:SetWidth(145);
        end
		factionButton:SetPoint("LEFT", factionRow, "LEFT", 3, 0);
        factionButton:Show();
		factionTitle:SetPoint("LEFT",factionButton,"RIGHT",10,0);
        factionTitle:SetFontObject(GameFontNormalLeft);
        factionBackground:Hide()    
        factionLeftTexture:SetHeight(15);
        factionLeftTexture:SetWidth(60);
        factionRightTexture:SetHeight(15);
        factionRightTexture:SetWidth(39);
        factionLeftTexture:SetTexCoord(0.765625, 1.0, 0.046875, 0.28125);
        factionRightTexture:SetTexCoord(0.0, 0.15234375, 0.390625, 0.625);
        factionBar:SetWidth(99);
    else
        if ( isChild ) then
            factionRow:SetPoint("LEFT", RWF_SubFrame, "LEFT", 25, 0);
            factionTitle:SetWidth(150);
        else
            factionRow:SetPoint("LEFT", RWF_SubFrame, "LEFT", 30, 0);
            factionTitle:SetWidth(160);
        end
		factionButton:Hide();
        factionTitle:SetPoint("LEFT", factionRow, "LEFT", 10, 0);
        factionTitle:SetFontObject(GameFontHighlightSmall);
        factionBackground:Show();
        factionLeftTexture:SetHeight(21);
        factionRightTexture:SetHeight(21);
        factionLeftTexture:SetTexCoord(0.7578125, 1.0, 0.0, 0.328125);
        factionRightTexture:SetTexCoord(0.0, 0.1640625, 0.34375, 0.671875);
        factionBar:SetWidth(101)
    end

    if ( (hasRep) or (not isHeader) ) then
        factionStanding:Show();
        factionBar:Show();
        factionBar:GetParent().hasRep = true;
    else
        factionStanding:Hide();
        factionBar:Hide();
        factionBar:GetParent().hasRep = false;
    end
end


function GetFloorInfo(index)
	local name, description, barMin, barMax, barValue, isHeader, hasRep, isChild, isCollapsed
    local T = ExaltedWithFloor.db.char.floorReps
    local sortted = sortTable(T)

	for i, value in ipairs(sortted) do
		if (i == index and T[value].isChild == false) then
			name = T[value].name
			description = T[value].desc
			barMin = T[value].barMin
			barMax = T[value].barMax
			barValue = T[value].barValue
			isHeader = T[value].isHeader
			hasRep = T[value].hasRep
			isChild = T[value].isChild
			isCollapsed = T[value].isCollapsed
			
		elseif (i == index and (T[value].isChild == true and T[value].isCollapsed == false)) then
			name = T[value].name
			description = T[value].desc
			barMin = T[value].barMin
			barMax = T[value].barMax
			barValue = T[value].barValue
			isHeader = T[value].isHeader
			hasRep = T[value].hasRep
			isChild = T[value].isChild
			isCollapsed = T[value].isCollapsed
		elseif (T[value].isCollapsed == true and T[value].isChild == true) then
			index = index + 1
		end
	end
	return name, description, barMin, barMax, barValue, isHeader, hasRep, isChild, isCollapsed
end

function sortTable(T)    
    local sortted = {}
    for v in pairs(T) do
        table.insert(sortted, v)
    end
    table.sort(sortted, function(a, b) return T[a].id < T[b].id end)

    return sortted
end

function GetFloorStandingText(index)
	local standing = ""
	local id = 1
    local T = ExaltedWithFloor.db.char.floorReps
    local sortted = sortTable(T)

	for i, value in ipairs(sortted) do
		if (i == index) then
			--Check if it is Unfriendly or Below first
			if (T[value].barMax == 3000) then
				standing = "Neutral"
				id = 1
				break
			elseif (T[value].barMax == 6000) then
				standing = "Friendly"
				id = 2
				break
			elseif (T[value].barMax == 12000) then
				standing = "Honored"
				id = 3
				break
			elseif (T[value].barMax == 21000) then
				standing = "Revered"
				id = 4
				break
			else
				standing = "Exalted"
				id = 5
				break
			end
		end
	end
	return standing, id
end

function RWFDeath()
	if (DEATH_COUNT == 0) then
		ExaltedWithFloor.timer = ExaltedWithFloor:ScheduleTimer(AllowDeath, 1);
		DEATH_COUNT = 1
		local name, type, _, difficulty = GetInstanceInfo()
		if ( type == "none" and (difficulty == "" or difficulty == 0) and name ~="Deeprun Tram" and name ~="Brawl'gar Arena" and name ~= "Stormshield" or name ~= "Warspear") then
			AwardFloorRep("World Floors")
		end
		AwardFloorRep(FloorType(name, type, difficulty))
	end
end

function AllowDeath()
	DEATH_COUNT = 0
end

function FloorType(name, type, difficulty)
	local floorType
	if (name == "Deeprun Tram" or name == "Brawl'gar Arena") then
		floorType = "Brawler's Guild"
	elseif (type == "raid") then
		for _, v in pairs(ExaltedWithFloor.db.char.floorReps) do
			if (v.name == name) then
				floorType = name
				break
			end
		end
		if (floorType == nil) then
			floorType = "Previous Raid"
		end
	elseif (type == "pvp") then
		for _, v in pairs(ExaltedWithFloor.db.char.floorReps) do
			if (v.name == name) then
				floorType = name
				break
			end
		end
	elseif (type == "party") then
		floorType = "Dungeon"
	elseif (type == "arena") then
		floorType = "Arena"
	elseif (type == "scenario") then
		floorType = "Scenario"
	elseif (type == "none" and (difficulty == "" or difficulty == 0)) then 
		floorType = RWF_WhereInTheWorld(GetCurrentMapContinent())
	else
		ExaltedWithFloor:Print("Error Occured: Name: "..name.." Type: "..type.." Difficulty "..difficulty)
		floorType = ""
	end

	return floorType
end

function AwardFloorRep(type)
    
	if ( type ~= "1" ) then
		local standing = ""
		if (type == "Previous Raid") then
			DEFAULT_CHAT_FRAME:AddMessage("Reputation with a "..type.." floor increased by 100.", 0.5,0.5,0.9)
		elseif (type == "Scenario") then
			DEFAULT_CHAT_FRAME:AddMessage("Reputation with the Scenario floor increased by 100.", 0.5,0.5,0.9)
		elseif (type == "World Floors") then
			DEFAULT_CHAT_FRAME:AddMessage("Reputation with the World floor increased by "..floor(100 / NUM_OF_WORLD_SUB_SECTIONS)..".", 0.5,0.5,0.9)
		else
			DEFAULT_CHAT_FRAME:AddMessage("Reputation with the "..type.." floor increased by 100.", 0.5,0.5,0.9)
		end

        local T = ExaltedWithFloor.db.char.floorReps
        local sortted = sortTable(T)

		for _, value in ipairs(sortted) do
			if ( T[value].name == type) then
				if (type == "World Floors") then
					T[value].barValue = floor(T[value].barValue + (100 / NUM_OF_WORLD_SUB_SECTIONS))
				else
					T[value].barValue = T[value].barValue + 20
				end
				if ( T[value].barValue > T[value].barMax )  then
					T[value].barValue = T[value].barValue - T[value].barMax
				
					if (T[value].barMax == 3000) then
						standing = "Friendly"
						T[value].barMax = 6000
					elseif (T[value].barMax == 6000) then
						standing = "Honored"
						T[value].barMax = 12000						
					elseif (T[value].barMax == 12000) then
						standing = "Revered"
						T[value].barMax = 21000						
					elseif (T[value].barMax == 21000) then
						standing = "Exalted"
						T[value].barMax = 999						
					else
						T[value].barValue = 999
						break						
					end
					local Msg
					if (type == "Previous Raid") then
						Msg = (UnitName("player").." has become "..standing.." with a "..type.." floor.")
					elseif (type == nil) then
						Msg = (UnitName("player").." has gained 100 reputation with the Scenario floor.")
					elseif (type == "World Floors") then
						Msg = (UnitName("player").." has become "..standing.." with the World floor.")
					else
						Msg = (UnitName("player").." has become "..standing.." with the "..type.." floor.")
					end
                    -- TODO give option to turn off or on these announcements
					print(Msg)
                    if (ExaltedWithFloor.db.profile.guildEnable) then
					    SendChatMessage(Msg, "GUILD")
                    end
					break
				end
			end
		end

		RWF_Update();
	end
end

function RWF_ExpandFactionHeader(id)
	local numFactions = RealTableLength(ExaltedWithFloor.db.char.floorReps)
	if (id < 15) then 
		local factionRowName = _G["RWF_ReputationBar"..id.."FactionName"];
		local name = factionRowName:GetText()
		for x, V in pairs(ExaltedWithFloor.db.char.floorReps) do
			if (V.name == name) then
				id = x
			end
		end
	end

	ExaltedWithFloor.db.char.floorReps[id].isCollapsed = false

	for i = id + 1, numFactions, 1 do
		if ( ExaltedWithFloor.db.char.floorReps[i].isChild == false ) then
			break
		else
			ExaltedWithFloor.db.char.floorReps[i].isCollapsed = false
		end
	end
	RWF_Update();
end

function RWF_CollapseFactionHeader(id)
	local numFactions = RealTableLength(ExaltedWithFloor.db.char.floorReps)
	if (id < 16) then 
		local factionRowName = _G["RWF_ReputationBar"..id.."FactionName"];
		local name = factionRowName:GetText()
		for x, V in pairs(ExaltedWithFloor.db.char.floorReps) do
			if (V.name == name) then
				id = x
			end
		end
	end

	ExaltedWithFloor.db.char.floorReps[id].isCollapsed = true

	for i = id + 1, numFactions, 1 do
		if ( ExaltedWithFloor.db.char.floorReps[i].isChild == false ) then
			break
		else
			ExaltedWithFloor.db.char.floorReps[i].isCollapsed = true
		end
	end
	RWF_Update();
end

function RWF_WhereInTheWorld(area)
	if (area == -1) then
		return "1"
	elseif (area == 0) then
		return "1"
	elseif (area == 1) then
		return "Kalimdor"
	elseif (area == 2) then
		return "Eastern Kingdoms"
	elseif (area == 3) then
		return "Outland"
	elseif (area == 4) then
		return "Northrend"
	elseif (area == 5) then
		return "1"
	elseif (area == 6) then
		return "Pandaria"
    elseif (area == 7) then
		return "Draenor"
    elseif (area == 8) then
		return "Broken Isles"
	end
end